//***********************************************
//*												*
//*		Jtk program							*
//*		Szerz: Bognr Andrs					*							
//*		Dtum:  2006 prilis					*
//*												*
//***********************************************

import java.applet.*;
import java.awt.*;
import java.util.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.applet.AudioClip;

//****************************************************************************************
//Nvjegy ablak
class nevjegy extends Frame{
//Felirat - Nested
	class Felirat extends Canvas{
		Image szoveg;
		public void paint(Graphics g){
			g.drawImage(szoveg,0,0,this);
		}
	}
//paramterek
	BorderLayout racs;
	public int exist;
	Felirat felirat;
//nvjegy ablak konstruktora
	public nevjegy(){
		super("Ezt n ksztettem!");
		racs=new BorderLayout();
		setLayout(racs);
		add(felirat=new Felirat(),"Center");
		pack();
		resize(210,245);
		setResizable(false);
		addWindowListener(new WindowAdapter(){				//X=exit
		public void windowClosing(WindowEvent we){
			hide();exist=0;
		}
		});
	}
//nvjegy ablak - metdusok
	public void megjelenit(){
		show(); exist=1;
		//while(exist==1){}
	}
}

//****************************************************************************************
//Help ablak
class help extends Frame{
//Felirat - Nested
	class Felirat extends Canvas{
		Image szoveg;
		public void paint(Graphics g){
			g.drawImage(szoveg,0,0,this);
		}
	}
//paramterek
	BorderLayout racs;
	public int exist;
	Felirat felirat;
//help ablak konstruktora
	public help(){
		super("Help - Segtsg");
		racs=new BorderLayout();
		setLayout(racs);
		add(felirat=new Felirat(),"Center");
		pack();
		resize(300,300);
		setResizable(false);
		addWindowListener( new WindowAdapter(){				//X=exit
		public void windowClosing(WindowEvent we){
			hide();exist=0;
		}
		});
	}
//help ablak - metdusok
	public void megjelenit(){
		show(); exist=1;
		//while(exist==1){}
	}
}

//****************************************************************************************
//Vge ablak
class vegeablaktip extends Frame{
//Vge felirat - Nested
	class vegeirat extends Canvas{
		int nyer=1;
		Image vegekep,vesztkep;
		public void paint(Graphics g){
			if(nyer==1) g.drawImage(vegekep,0,0,this);
			else g.drawImage(vesztkep,0,0,this);
		}
	}
//Vgeablak Folyt.
	private boolean exist;
	vegeirat felirat;
	BorderLayout racs;
	
//Vgeablak konstruktor
	public vegeablaktip(){
	super("Vge a jtknak!");
	exist=false;
	racs=new BorderLayout();
	setLayout(racs);
	add(felirat=new vegeirat(),"Center");
	add(new Button("Jvan Hzz akkor..."),"South");
	pack();
	resize(310,220);
	setResizable(false);
	addWindowListener( new WindowAdapter(){				//X=exit
		public void windowClosing(WindowEvent we){
			hide();exist=false;
		}
		});
	}
	public boolean action(Event esemeny,Object miaz){	//Button=exit
		if(esemeny.target instanceof Button){
			hide();exist=false;
		}
		return true;
	}
	public boolean keyDown(Event event,int betu){		//Enter=Exit
		if(betu==10){hide();exist=false;}
		return(true);
	}
	public void setveszt(){
		felirat.nyer=0;
	}
	public void resetnyer(){
		felirat.nyer=1;
	}
	public int givestate(){
		return(felirat.nyer);
	}
	public void mutat(){				//Show the window and Wait for the exit
		show();toFront(); exist=true;
		while(exist){}
	}	
	public boolean isexist(){return(exist);}
}

//****************************************************************************************
//Felugr ablak - gombnyomsra
class felugro extends Frame{
	Button gb;
	int exist;
//felugr konstruktora
	public felugro(){
		super("Ne szrakozz!!! HA?");
		gb=new Button("Tovbb - Na!Nyomjad!");
		add(gb);
		pack();
		resize(300,100);
		show();
		setResizable(false);
		exist=1;
		addWindowListener( new WindowAdapter(){				//X=exit
		public void windowClosing(WindowEvent we){
			hide();exist=0;
		}
		});
	}
//felugr methods
	public boolean isexist(){
		if(exist==1)return true;
		return false;
	}
	public boolean action(Event esemeny,Object miaz){	//Button=exit
		if(esemeny.target instanceof Button){
			hide();exist=0;
		}
		return true;
	}
	public boolean keyDown(Event event,int betu){		//Enter=Exit
		if(betu==10){hide();exist=0;}
		return(true);
	}
}

//**************************************************************************************
//Kezd ablak
class startablak extends Frame{
//Startablak vszna -nested
	class vaszon1 extends Canvas{
		Image stkep;
		public void paint(Graphics g){
			g.drawImage(stkep,0,0,this);
		}
	}
//Startablak folyt.
	vaszon1 v;
	int exist=1;
	public startablak(){
		v=new vaszon1();
		BorderLayout b=new BorderLayout();
		setLayout(b);
		add(v,"Center");
		add(new Button("Start Game"),"South");
		pack();
		resize(255,250);
		show();
		exist=1;
		addWindowListener( new WindowAdapter(){				//X=exit
		public void windowClosing(WindowEvent we){
			hide();exist=0;
		}
		});
	}
//Startablak methods
	public boolean isexist(){
		if(exist==1)return true;
		else return false;
	}
	public boolean action(Event esemeny,Object miaz){		//Button=exit
		if(esemeny.target instanceof Button){
			exist=0;hide();
		}
		return true;
	}
	public boolean keyDown(Event event,int betu){			//Enter=Exit
		if(betu==10){hide();exist=0;}
		return(true);
	}
}

//****************************************************************************************
//Fablak
class ablakom extends Frame implements Runnable{ 
	
//Fablak vszna  -nested
	class Vasznak extends Canvas{ 
		int lx=50,ly=150,mx=2,my=10;	//alakzatok pos.
		int bx,by;						//bomba pos.
		int lovx,lovy;					//lvedk pos.
		int loves=0;					//1=lvs folyamata
		int ejt=0;						//bombt ejt
		//int veszt=0;
		public Image lovo,mozog,hatter,lovedek,bomba;
		public boolean kepbent=false;
		boolean Kepbent=false;
		
		public void tolt(){				//load picture
			Image Ernyonkivuli=createImage(size().width,size().height);
			Graphics ErnyonkivuliGr=Ernyonkivuli.getGraphics();
			ErnyonkivuliGr.drawImage(hatter,0,0,this);
		}
		public void set(int lx,int ly,int mx,int my){  //set the positions
			this.lx=lx;this.ly=ly;this.mx=mx;this.my=my; 
			repaint();
		}
		public void paint(Graphics g){
			if(kepbent){g.drawImage(hatter,0,0,null);
				        if(lx>-1)g.drawImage(lovo,lx,ly,this);
						if(mx>-1)g.drawImage(mozog,mx,my,this);
						if(loves==1)g.drawImage(lovedek,lovx,lovy,this);
						if((ejt==1)&&(mx>-1))g.drawImage(bomba,bx,by,this);
			           }
									 }
		public boolean imageUpdate(Image img,int infoflags,int x,int y,int w,int h){
			if(infoflags==ALLBITS){
				Kepbent=true;
				repaint();
				return false;
			}
			return true;
		}
		
	}
//Fablak folyt.
	int mirany=1;			//1=jobbra; 2=balra;
	int sebesseg=100;
	int ido=0;				//ejtsi ksl.
	Thread Szal=null;
	int fut=1,pause=0;		//llapotvltozk
	int halt=0;				//szl fojtsa
	int mdir=1,lo=0;
	Vasznak vaszon;
	vegeablaktip vegeablak;	//Vge ablak
	felugro felugrik;		//felugr ablak
	nevjegy nevjegyablak;	//nvjegy ablak
	help helpablak;			//help ablak
	BorderLayout kinezet;
	Button g1;
	int szin=1;
	AudioClip au1,au2,au3,au4,au5,au6; //Audioklippek
//Fablak konstruktora
	public ablakom(String focim){
		super(focim);
		MenuBar menusor=new MenuBar();
		setMenuBar(menusor);
		
		Menu menunev=new Menu("Innen vlassz!",false);
		menusor.add(menunev);
		menunev.add(new MenuItem("j jtk"));
		menunev.add(new MenuItem("Valami mst!"));
		menunev.add(new MenuItem("Hzs kifel!"));
		
		Menu menunev2=new Menu("FlBeSg",false);
		menusor.add(menunev2);
		menunev2.add(new MenuItem("Hogy is kell?"));
		menunev2.add(new MenuItem("Chef Programmer"));
		
		setBackground(Color.black);
		setResizable(true);
		kinezet=new BorderLayout();
		setLayout(kinezet);
		vaszon=new Vasznak();
		vaszon.setBackground(Color.black);
		add(vaszon,"Center");
		g1=new Button("Atomabbt");
		add(g1,"South");
		
		pack();
		resize(300,300);
		
		show();
		g1.resize(100,30);
		setResizable(false);
		addWindowListener( new WindowAdapter(){				//X=exit
		public void windowClosing(WindowEvent we){
			hide();halt=1;while(true){}							//KILL
		}
		});
		//gyermekablakok
		vegeablak=new vegeablaktip();	
		nevjegyablak=new nevjegy();
		helpablak=new help();
		start();
	}
//Fablak szlindts
	public void start(){				//Szl ltrehozs
		if(Szal==null){
			Szal=new Thread(this);
			Szal.start();
		}
	}
//Fablak szl
	public void run(){					//Run szl a program f irnytja
	  while(true){
		//Fut=1 esetn a mozgat ciklus fut
		while(fut==1){
			//ksleltets
			try{Szal.sleep(sebesseg);}
			catch(InterruptedException e){}
			//"atomabbt" ablak okozta halt
			while(pause==1){while(felugrik.isexist()){} sebesseg=40;pause=0;}
			//help men okozta lellts
			while(nevjegyablak.exist==1){}
			while(helpablak.exist==1){}
			//szl meggyilkolsa
			while(halt==1){}
			//Cltrgy mozgatsa
			if((vaszon.mx<298)&&(mirany==1)){vaszon.mx+=10;vaszon.repaint();}
			if(vaszon.mx>298)mirany=2;
			if((vaszon.mx>0)&&(mirany==2)){vaszon.mx-=10;vaszon.repaint();}
			if(vaszon.mx<0)mirany=1;
			//Lvedk mozgatsa
			if(vaszon.loves==1){
				vaszon.lovy-=10;
				if(vaszon.lovy<0){vaszon.loves=0;}
				if(vaszon.lovy<30){
					if((vaszon.mx<vaszon.lovx+5)&&(vaszon.mx+30>vaszon.lovx+5))
					  {au6.play();fut=0;vaszon.loves=0;}
				                 }
			}
			//Bomba mozgatsa
			ido++;				//Bomba idzt
			if(ido==10){
				ido=0; vaszon.ejt=1; vaszon.bx=vaszon.mx; vaszon.by=vaszon.my;
			}
			if(vaszon.ejt==1){	//Ejtsi mvelet
				vaszon.by+=20;
				if(vaszon.by>120){
					if((vaszon.bx>vaszon.lx)&&(vaszon.bx<vaszon.lx+50))
						{au1.play();fut=0;vegeablak.setveszt();}
					if((vaszon.bx+30>vaszon.lx)&&(vaszon.bx+30<vaszon.lx+50))
						{au1.play();fut=0;vegeablak.setveszt();}
				}
				if(vaszon.by>250)vaszon.ejt=0;
			}
		}
		//fut==0 estn kilp a mozgatsi ciklus:
		toBack();
		hide();
		if(vegeablak.givestate()==1)au4.play();
		else au2.play();
		vegeablak.mutat();	//Vgeablakot kiteszi s megvrja mg kilp
		vaszon.loves=0;vaszon.repaint();
		show();toFront();
		vaszon.lx=-2;vaszon.mx=-2;vaszon.repaint();remove(g1);
		while(fut!=1){}
		vaszon.lx=50; vaszon.mx=2;
		add(g1,"South");
		g1.resize(100,30);
		sebesseg=100;vegeablak.resetnyer(); vaszon.ejt=0; vaszon.loves=0;
	              }
	}
//Fablak event kezelk
	public boolean keyDown(Event event,int betu){
		//bal=1006   jobb=1007    fel=1004
		if(fut==1){
		 if(betu==1006){if(vaszon.lx>0)vaszon.lx-=10;}	//balra mozgs
		 if(betu==1007){if(vaszon.lx<240)vaszon.lx+=10;}	//jobbra mozgs
		 if(betu==1004){								//lvs
			au3.play();
			if(vaszon.loves!=1){vaszon.loves=1;
				vaszon.lovx=vaszon.lx+20;vaszon.lovy=130;}}
		 vaszon.repaint();
		}
		return true;
	}
	public boolean action(Event esemeny,Object miaz){
		String cimke=(String)miaz;
		if(esemeny.target instanceof MenuItem){
			if(cimke.equals("Hogy is kell?")){helpablak.megjelenit();}
			if(cimke.equals("Chef Programmer")){nevjegyablak.megjelenit();}
		}
		if(esemeny.target instanceof MenuItem){
			if(cimke.equals("j jtk")) if(!vegeablak.isexist())if(fut==0){fut=1;}
			if(cimke.equals("Hzs kifel!")){ hide();fut=0; }
			if(cimke.equals("Valami mst!")) 
				switch(szin){
				case 1: setBackground(Color.green); szin=2;break;
				case 2: setBackground(Color.blue); szin=3;break;
				case 3: setBackground(Color.yellow); szin=4;break;
				case 4: setBackground(Color.red); szin=1;break;
				default: szin=1;
				}
		}
		if(fut==1){
		 if(esemeny.target instanceof Button){
			felugrik=new felugro();pause=1;
			remove(g1);
			felugrik.toFront(); 
		 }
		}
		repaint();
		return true;
	}
}

//***************************************************************************************
//Applet osztly innen indul a program
public class Jatek extends Applet {
	ablakom ablak;
	AudioClip au5;
	
	public void init() {		//Inicializci, a jtk indtsa
	  au5=getAudioClip(getCodeBase(),"ready.au");
	  au5.play();
	  startablak st=new startablak();
	  st.v.stkep=getImage(getCodeBase(),"start.jpg");
	  st.v.repaint();
	  while(st.isexist()){}
	  
	  ablak=new ablakom("Bummafejbe Jtk - Quenne Electric");	//Fablak
	  ablak.vaszon.lovo=getImage(getCodeBase(),"lovo.jpg");		//Kpek betltse
	  ablak.vaszon.mozog=getImage(getCodeBase(),"mozog.jpg");
	  ablak.vaszon.lovedek=getImage(getCodeBase(),"lovedek.jpg");
	  ablak.vaszon.bomba=getImage(getCodeBase(),"bomba.jpg");
	  ablak.vaszon.hatter=getImage(getCodeBase(),"hatter.jpg");
	  ablak.vegeablak.felirat.vegekep=getImage(getCodeBase(),"vege.jpg");
	  ablak.vegeablak.felirat.vesztkep=getImage(getCodeBase(),"veszt.jpg");
	  
	  ablak.nevjegyablak.felirat.szoveg=getImage(getCodeBase(),"nev.jpg");
	  ablak.helpablak.felirat.szoveg=getImage(getCodeBase(),"helpsz.jpg");
	  
	  //audioklippek betltse
	  ablak.au1=getAudioClip(getCodeBase(),"explode.au");
	  ablak.au2=getAudioClip(getCodeBase(),"gameo.au");
	  ablak.au3=getAudioClip(getCodeBase(),"loves.au");
      ablak.au4=getAudioClip(getCodeBase(),"nyer.au");
	  ablak.au6=getAudioClip(getCodeBase(),"robban.au");
	  
	  ablak.vaszon.kepbent=true;
	  ablak.vaszon.tolt();				//Httrkp betltse
	}
}